% ech_demo.m
% Fichier de dmonstration du thoreme d'chantillonnage en traitement de signal analogique - numrique
% Le programme montre l'effet de l'chantillonage sur la reconstruction d'un signal
%
% Le signal test est compos de 3 sinusoides de frquences 50, 150, et 250 Hz
% Il s'agit de fixer la frquence d'chantillonnage pour visualiser les effets du thoreme et du taux de Nyquist
% 
% David Legault - Ing.
% tudiant de Maitrise en Gnie lectrique - Groupe de Recherche en Tlcommunications
% cole Polytechnique de Montral


% N = nombre de points par priode du signal - N grand = plus de prcision
N = 500;
% NT = nombre de priodes d'affichage du signal
NT = 8;
% fe = frquence d'chantillonnage
fe = 400;
Te = 1/fe;

% f = frequence minimale du signal test
f = 50;
T = 1/f;


% construction du signal test
t = 0:T/N:NT*T;
x = stest(f,t);

ne = floor(NT*T/Te);

%te = 0:1:ne-1;
%te = 1/2;
te = 1/2:1:ne-1/2;
te = te*Te;
xe = stest(f,te);

subplot(3,1,1);
plot(t,x,te,xe,'rs','LineWidth',2,'MarkerEdgeColor','k','MarkerFaceColor','g','MarkerSize',5);
title('Signal chantillonn');
xlabel('Temps (s)');

% recreer le signal original apres l'avoir echantillonn
i = 1;
ft = [];
while i <= length(t)
    ft = [ ft srecon(t(i),xe,te,Te)];
    i = i + 1;
end

ft;

Nfft = 256;

Y = fft(xe,Nfft);
Y = fftshift(Y);
%The power spectrum, a measurement of the power at various frequencies, is 
Pyy = Y.* conj(Y) / Nfft;
%Graph the first 257 points (the other 255 points are redundant) on a meaningful frequency axis: 
f = fe*(-Nfft/2:Nfft/2-1)/(Nfft);
%f = fe*(0:(length(xe)/2))/(length(xe));

Pyy = sqrt(Pyy);

subplot(3,1,2);
%plot(f,Pyy(1:(length(xe)/2+1)))
%bar(f,Pyy(1:floor((length(xe))/2+1)),0.05)
bar(f,Pyy,0.05)
axis([min(f) max(f) min(Pyy) max(Pyy)]);
title('Spectre du signal chantillonn');
xlabel('Frquence (Hz)');


subplot(3,1,3);
plot(t,ft);
axis([0 max(t) -1 1]);
title('Signal Reconstruit');
xlabel('Temps (s)');

