% David Legault 1070008
% Fichier: Htf_sinus.m
% Description: Fonction qui retourne la rponse frquentielle d'un filtre LPTV utilisant m(t) fonction sinusoidale 
% aux variables t et f donnes
%
% Fonctions: Htf_sinus(t,f,T0,H)
%
% Variables:
%           t = temps
%           f = frquence
%           T0 = priode du filtre LPTV
%           H = parametre donnant le choix entre 2 versions du filtre (utilis dans le cas multi-utilisateur)

function y = Htf_sinus(t,f,T0,H)

% frquence modulaire
w0 = 2*pi/T0;
% amplitude
alpha = T0;

if H == 1
  alpha = 4*T0;
  y = exp(-i*2*pi*f*alpha*sin(w0*t));
else
  alpha = 4*T0;
  y = exp(i*2*pi*f*alpha*sin(w0*t));
end
