% David Legault 1070008
% Fichier: cal_Ak.m
% Description: Fonction qui calcul les signaux Ak(t) en calculant d'abord le produit Z(f) X psik(f) puis en effectuant une
% transforme inverse de Fourier pour trouver les Ak(t).
%
% Fonctions: cal_Ak(Zf,Nk,N,psk,dfe,dt)
%
% Variables:
%           Zf = FFT du signal z entrant
%           Nk = nombre de coefficients de Fourier du filtre a considrer
%           N = nombre d'chantillons en temps/frquence
%           psk = matrice des coefficient psi_k(f)
%           dfe = intervalle frquentiel d'chantillonnage
%           dt = intervalle temporel d'chantillonnage

function y = cal_Ak(Zf,Nk,N,psk,dfe,dt)

% vecteur nul
y = zeros(Nk+1,N);

% boucle sur les nombres k
k = 1;
while (k <= Nk)
     
    % boucle sur la frquence
    j = 1;    
    while (j <= N)

        y(k,j) = psk(k,j)*Zf(j);
        
        j = j + 1;
    end
    
    k = k + 1;
end

% FFT-1 pour ramener le tout en vecteur temporel
y = ifftshift(y,2);
y = ifft(y,[],2);