% David Legault 1070008
% Fichier: filtre.m
% Description: Fichier principal du simulateur
%
% Conu sous Matlab 6.5.1

% effacer toutes les variables avant le calcul
clear;

% priode du filtre
T0 = 1;
% temps d'un bit
Tb = 2;
% nombre de points dans le calcul
N = 1024;
% nombre d'chantillons pour la priode T0
Nt = 16;
% nombre de coefficients de Fourier (toujours Nk+1 et doit etre un nombre pair)
Nk = 16;
% priode d'chantillonage
dt = T0/Nt;
% cart frquentiel des chantillons
dfe = 1/(dt*N);

% vecteur du signal d'entre
z = rand_nrz(Tb/dt,N/(Tb/dt));
%z = nrz(Tb/dt,N/(Tb/dt));
%z = sinus(pi/(Tb),dt,N);

% spectre du signal initial
zf = fftshift(fft(z,N));

% filtrage pour limiter la largeur de bande de z(t)
zf = fpassb(zf,(2/Tb)*dt*N,0);
tz = 0:dt:(N - 1)*dt;
figure(50);
plot(tz,zf);
z = ifft(ifftshift(zf));

%%% calcul des coefficients psi_k %%%
psk = psk(Nk,dfe,dt,T0,N,0);

% calcul des signaux Ak
Ak = cal_Ak(zf,Nk,N,psk,dfe,dt);

% sommation finale du vecteur rsultat x(t)
x = real(xt(Ak,T0,dt));

% variables pour les graphiques
x = x(1,1:length(z));
t = 0:dt:(length(x)-1)*dt;

% affichage des 4 graphiques Entr/Sortie
t_graph(t,x,1,'Fonction Temporelle de Sortie');
t_graph(t,z,2,'Fonction Temporelle d`Entre');
w_spectre(x,dt,3,'Spectre de Sortie');
w_spectre(z,dt,4,'Spectre de l`Entre');







