% David Legault 1070008
% Fichier: 
% Description: Fichier de simulation de systeme multi-utilisateur de filtres LTPV
%

% effacer toutes les variables avant le calcul
clear;

% priode du filtre
T0 = 1;
% temps d'un bit
Tb = 2;
% nombre de points dans le calcul
N = 1024;
% nombre d'chantillons pour la priode T0
Nt = 16;
% nombre de coefficients de Fourier (toujours Nk+1 et doit etre un nombre pair)
Nk = 16;
% priode d'chantillonage
dt = T0/Nt;
% cart frquentiel des chantillons
dfe = 1/(dt*N);

% vecteur du signal d'entre
z = rand_nrz(Tb/dt,N/(Tb/dt));
%z2 = z;
z2 = rand_nrz(Tb/dt,N/(Tb/dt));
%z = nrz(Tb/dt,N/(Tb/dt));
%z = sinus(pi/(Tb),dt,N);

%%% calcul des coefficients psi_k %%%
pskz = psk(Nk,dfe,dt,T0,N,1);
pskz2 = psk(Nk,dfe,dt,T0,N,2);

% spectre du signal initial
zf = fftshift(fft(z,N));
zf2 = fftshift(fft(z2,N));

zf = fpassb(zf,dt*N,0);
zf2 = fpassb(zf2,dt*N,0);
tz = 0:dt:(N - 1)*dt;

z = ifft(ifftshift(zf));
z2 = ifft(ifftshift(zf2));
%t_graph(tz,zf,50,'Z1 filtr');
%t_graph(tz,zf2,51,'Z2 filtr');

% calcul des signaux Ak
Ak = cal_Ak(zf,Nk,N,pskz,dfe,dt);
Ak2 = cal_Ak(zf2,Nk,N,pskz2,dfe,dt);

% sommation finale du vecteur rsultat x(t)
x = real(xt(Ak,T0,dt));
x2 = real(xt(Ak2,T0,dt));

% variables pour les graphiques
t = 0:dt:(length(x)-1)*dt;

% affichage des 4 graphiques Entr/Sortie
t_graph(t,t_nrz(z),1,'Fonction Temporelle Entree Z1');
t_graph(t,t_nrz(z2),2,'Fonction Temporelle Entree Z2');
t_graph(t,t_nrz(x),3,'Fonction Temporelle Sortie X1');
t_graph(t,t_nrz(x2),4,'Fonction Temporelle Sortie X2');

w_spectre(z,dt,5,'Spectre Entree Z1');
w_spectre(z2,dt,6,'Spectre Entree Z2');

fa  = 0:1/(dt*N):1/dt - 1/(dt*N);
fa = fa - fa(ceil(length(fa)/2) + 1);
xf = fftshift(fft(x));
xf2 = fftshift(fft(x2));
%t_graph(fa,xf,7,'FFT Sortie X1');
%t_graph(fa,xf2,8,'FFT Sortie X2');

x3 = x + x2;
t_graph(t,x3,9,'Fonction Temporelle Sortie X1 + X2 = X');
w_spectre(x3,dt,10,'Spectre Sortie X1 + X2 = X');








