% David Legault 1070008
% Fichier: fpassb.m
% Description: Fonction permettant de d'extraire une bande B d'un spectre numrique et de le ramener en bande de base centr sur f = 0 
%
% Fonctions: fpassb(x, Nb, B)
%
% Variables:
%             x = spectre du signal a filtrer
%             Nb = Nombre de points dfinissant la largeur d'une bande
%             B = numro de la bande a isoler (B = 0 est la bande de base a f = 0)

function y = fpassb(x,Nb,B)

N = length(x);

% bourrage de zro a gauche
y = zeros(1,N/2-Nb/2);

% extraction de la bande B
y = [y x(1,N/2+(2*B-1)*Nb/2+1:N/2+(2*B+1)*Nb/2)];

% bourrage de zro a droite
y = [y zeros(1,N/2 - Nb/2)];
  





