% David Legault 1070008
% Fichier: noise-check
% Description: Fonction qui calcul la variance entre le signal reconstruit et le signal original dans le
%              but de mesurer la rsistance au bruit de la reconstruction
%
% Fonctions: noise_check(x,t,psk,dt,N,Nk,T0,z,H)
%
% Variables:
%             x = signal filtr
%             t = vecteur temps
%             psk = vecteur des coefficients du signal z
%             dt = priode entre les chantillons
%             N = longueur du vecteur x
%             Nk = nombre de sous-bandes de coefficient dans x
%             T0 = priode du filtre
%             z = signal original z1
%             H = variable identifiant si la reconstruction est sur moyennage ou sur bande unique


function y = noise_check(x,t,psk,dt,N,Nk,T0,z,H)

nyx = [];
var = [];
snrt = [];

SNRs = -10;
SNRe = 20;
a = 0;
Nsnr = 150;

while a <= Nsnr
  
  snr = SNRs + a*(SNRe - SNRs)/Nsnr;
  nx = awgn(x,snr,'measured');
  nyx = recons(nx,t,psk,dt,N,Nk,T0,z,H);
  
  %figure(101);
  %plot(t,t_nrz(z),t,nyx,'--k','LineWidth',2);
  %xlim([min(t) max(t)]);
  %legend('original','reconstruit');
  
  % calcul de la variance ici en fonction du SNR
  j = 1;
  varx = 0;
  while j <= N
  
    varx = varx + (nyx(1,j) - z(1,j))^2;
    j = j + 1;
  end
  
  snrt = [snrt snr];
  var = [var real(varx/N)];
  a = a + 1;
end

%figure(100);
%plot(snrt,var);

y = var;
