% David Legault 1070008
% Fichier: noise_check_mean.m
% Description: Fonction qui calcul la variance entre une signal reconstruit et l'orignal sur une longue
%              srie de rptitions dans le but d'liminer l'ala de l'influence du bruit BBG sur la reconstruction
%
% Fonctions: noise_check_mean(x,t,psk,dt,N,Nk,T0,z,H)
%
% Variables:
%             x = signal filtr
%             t = vecteur temps
%             psk = vecteur des coefficients du signal z
%             dt = priode entre les chantillons
%             N = longueur du vecteur x
%             Nk = nombre de sous-bandes de coefficient dans x
%             T0 = priode du filtre
%             z = signal original z1
%             H = variable identifiant si la reconstruction est sur moyennage ou sur bande unique


function y = noise_check_mean(x,t,psk,dt,N,Nk,T0,z,H)

snrm = [];

a = 1;
Nm = 10000;

SNRs = -10;
SNRe = 20;
Nsnr = 150;
snr = SNRs:(SNRe - SNRs)/Nsnr:SNRe;

var = zeros(1,Nsnr+1);

while a <= Nm

  var = var + noise_check(x,t,psk,dt,N,Nk,T0,z,H);
  
  a = a + 1;
end 

var = var / Nm;

%figure(102);
%plot(snr,var);

y = var;
