% David Legault 1070008
% Fichier: psi_k.m
% Description:  calcul d'un coefficient de la matrice des coefficients psi_k(f) en utilisant la valeur du filtre pour
% une valeur de frquence f donne
%
% Fonctions: psi_k(k,f,T0,H)
%
% Variables:
%           k = kieme coefficient
%           f = frquence de calcul du coefficient
%           T0 = priode du filtre
%           H = nombre indiquant quelle version de filtre utiliser

function res = psi_k(k,f,T0,H)

% nombre de points dans l'intgrale
N = 256;
% intervalle d'intgration
dt = T0/N;

% dbut de la borne d'intgration infrieure
t = -T0/2;
% rsultat initialis
res = 0;
% frquence modulaire
w0 = 2*pi/T0;

while (t <= T0/2)

  % choix de la fonction du filtre multipli par le coefficient de Fourier
  %res = res + Htf_dent(t,f,T0,H)*exp(-i*w0*k*t)*dt;
  %res = res + Htf_sinus(t,f,T0,H)*exp(i*w0*k*t)*dt;
  res = res + Htf_t_carre(t,f,T0,H)*exp(i*w0*k*t)*dt;
  
  t = t + dt;
end
        
% multiplication par la constante 1/T0
res = res / T0;