% David Legault 1070008
% Fichier: psk.m
% Description: cre la matrice des coefficients psi_k(f)
%  
% dbute a -Nk/2 jusqu'a Nk/2 sur les lignes et va de -fe/2 a fe/2 par pas de dfe dans le sens des colonnes pour la
% frquence (multiplication de j*dfe)
%
% comme les indices ngatifs ne sont pas utiliss en Matlab, la fonction fait une translation des indices en k et f pour
% que le point 0,0 de la matrice correspond a la valeur (-Nk/2,-fe/2) -> (Nk/2,fe/2) pour le dernier point de la matrice
%
% Fonctions: 
%           psk = fonction de calcul des coefficients
%           psi_k = calcul d'un coefficient pour une frquence et un k donne 
%
% Variables:
%           Nk = nombre de coefficients (toujours gal a Nk + 1 car [-Nk/2,Nk/2])
%           dfe = delta de frquence d'chantillonnage
%           dt = intervalle de temps entre chacun des chantillons
%           T0 = frquence priodique du filtre
%           N = nombre de points en frquence dans le calcul
%           H = nombre indiquant quelle version de filtre utiliser

function y = psk(Nk,dfe,dt,T0,N,H)

% matrice initiale
y = zeros(Nk+1,N);

% dbute a -Nk/2
k = -Nk/2;
while (k <= Nk/2)
    
    yk = k + Nk/2 + 1;
    
    j = -N/2;
    while (j <= N/2-1)

        yj = j + N/2 + 1;
        
        % calcul du coeficient (k,j) de la matrice
        y(yk,yj) = psi_k(k,j*dfe,T0,H);
        
        j = j + 1;
    end
    
    k = k + 1;
end