% David Legault 1070008
% Fichier: recons.m
% Description: Fonction qui reconstruit un signal NRZ bas sur les valeurs chantillonnes du signal
%
% Fonctions: recons(x,t,psk,dt,N,Nk,T0,z,H)
%
% Variables:
%             x = signal filtr
%             t = vecteur temps
%             psk = vecteur des coefficients du signal z
%             dt = priode entre les chantillons
%             N = longueur du vecteur x
%             Nk = nombre de sous-bandes de coefficient dans x
%             T0 = priode du filtre
%             z = signal original z1
%             H = variable identifiant si la reconstruction est sur moyennage ou sur bande unique

function y = recons(x,t,psk,dt,N,Nk,T0,z,H)

%w_spectre(x,dt,42,'Spectre total bruit+signal');

y = fftshift(fft(x));
f = 0:1:length(x) - 1;
%t_graph(f,y,5,'Rponse fft');

% bande 0
y2 = fpassb(y,dt*N,0);
y2 = y2.*(psk(Nk/2+1,:).^(-1));
y2 = real(ifft(ifftshift(y2)));

% bande 1
y3 = fpassb(y,dt*N,1);
y3 = y3.*(psk(Nk/2+1+1,:).^(-1));
y3 = real(ifft(ifftshift(y3)));

%bande -1
y4 = fpassb(y,dt*N,-1);
y4 = y4.*(psk(Nk/2+1-1,:).^(-1));
y4 = real(ifft(ifftshift(y4)));

% bande 2
y6 = fpassb(y,dt*N,2);
y6 = y6.*(psk(Nk/2+1+2,:).^(-1));
y6 = real(ifft(ifftshift(y6)));

% bande -2
y7 = fpassb(y,dt*N,-2);
y7 = y7.*(psk(Nk/2+1-2,:).^(-1));
y7 = real(ifft(ifftshift(y7)));

% bande 2
y8 = fpassb(y,dt*N,3);
y8 = y8.*(psk(Nk/2+1+3,:).^(-1));
y8 = real(ifft(ifftshift(y8)));

% bande -2
y9 = fpassb(y,dt*N,-3);
y9 = y9.*(psk(Nk/2+1-3,:).^(-1));
y9 = real(ifft(ifftshift(y9)));

% graphique des N bandes reconstitues
%figure(16);
%plot(t,y2,t,y3,t,y4,t,y6,t,y7);
%legend('bande 0','bande 1','bande -1','bande 2','bande -2');
%plot(t,y2,t,y3,t,y4,t,y6,t,y7,t,y8,t,y9);
%legend('bande 0','bande 1','bande -1','bande 2','bande -2','bande 3','bande -3');
%xlim([min(t) max(t)]);

% signal reconstruit par moyennage
%y = (y2+y3+y4+y6+y7+y8+y9)/7;
%y = (y2+y3+y4+y6+y7)/5;
%y = (y3+y4+y6+y7)/4;
%y = (y2+y3+y4)/3;
%y = (y3+y4)/2;
%y = y2;

if H == 1
  y = (y2+y3+y4+y6+y7+y8+y9)/7;
else
  y = y2;
end

%figure(17);
%plot(t,t_nrz(z),t,y,'--k','LineWidth',2);
%xlim([min(t) max(t)]);
%legend('original','reconstruit');
