% David Legault 1070008
% Fichier: recons2.m
% Description: Fonction qui reconstruit un signal NRZ bas sur les valeurs chantillonnes du signal
%              lorsqu'il y a chevauchement de bandes entre [-f0,f0]
%
% Fonctions: recons2(x,t,psk,dt,N,Nk,T0,z)
%
% Variables:
%             x = signal filtr
%             t = vecteur temps
%             psk = vecteur des coefficients du signal z
%             dt = priode entre les chantillons
%             N = longueur du vecteur x
%             Nk = nombre de sous-bandes de coefficient dans x
%             T0 = priode du filtre
%             z = signal original z1

function y = recons2(x,t,psk,dt,N,Nk,T0,z)

Nb = 2*dt*N;

% ajouter du bruit ici
wgn = 0.1*randn(1,N);
wgni = 1:1:N;
figure(40);
plot(wgni,wgn);
xlim([min(wgni) max(wgni)]);
%w_spectre(wgn,dt,41,'Spectre du bruit');

%nx = x + wgn;
nx = x;

fa  = 0:1/(dt*N):1/dt - 1/(dt*N);
fa = fa - fa(ceil(length(fa)/2) + 1);
y = fftshift(fft(nx));
t_graph(fa,y,5,'Rponse fft signal + bruit');

%%%%%% PARTIE f = [0,f0[
% bande 0
Xf0 = fpassb2(y,Nb,0,1,1);
f = 0:1:length(Xf0) - 1;
%t_graph(f,Xf0,6,'Rponse fft Xf0');

% bande 1
XfM1 = fpassb2(y,Nb,0,-1,1);
%t_graph(f,XfM1,7,'Rponse fft Xf1');

PSK0_G = fpassb2(psk(Nk/2+1,:),Nb,0,-1,1);
%t_graph(f,PSK0_G,8,'PSK0_G bande gauche de Psi K = 0');

PSK0_D = fpassb2(psk(Nk/2+1,:),Nb,0,1,1);
%t_graph(f,PSK0_D,9,'PSK0_D bande gauche de Psi K = 0');

PSKP1_G = fpassb2(psk(Nk/2+2,:),Nb,0,-1,1);
%t_graph(f,PSKP1_G,10,'PSKP1_G bande gauche de Psi K = 1');

PSKM1_D = fpassb2(psk(Nk/2,:),Nb,0,1,1);
%t_graph(f,PSKM1_D,11,'PSKM1_D bande droite de Psi K = -1');

% calcul de la bande de droite
NZ0f1 = PSK0_G.*Xf0 - PSKP1_G.*XfM1;
DZ0f1 = PSK0_D.*PSK0_G - PSKM1_D.*PSKP1_G;
Z0f_D = NZ0f1./DZ0f1;

%%%%%% PARTIE f = [-f0,0[

% bande 0
Xf0 = fpassb2(y,Nb,0,-1,-1);
f = 0:1:length(Xf0) - 1;
%t_graph(f,Xf0,6,'Rponse fft Xf0');

% bande 1
XfM1 = fpassb2(y,Nb,0,1,-1);
%t_graph(f,XfM1,7,'Rponse fft Xf1');

PSK0_G = fpassb2(psk(Nk/2+1,:),Nb,0,-1,-1);
%t_graph(f,PSK0_G,8,'PSK0_G bande gauche de Psi K = 0');

PSK0_D = fpassb2(psk(Nk/2+1,:),Nb,0,1,-1);
%t_graph(f,PSK0_D,9,'PSK0_D bande droite de Psi K = 0');

PSKP1_G = fpassb2(psk(Nk/2+1+1,:),Nb,0,-1,-1);
%t_graph(f,PSKP1_G,10,'PSKP1_G bande gauche de Psi K = 1');

PSKM1_D = fpassb2(psk(Nk/2,:),Nb,0,1,-1);
%t_graph(f,PSKM1_D,11,'PSKM1_D bande droite de Psi K = -1');

% calcul de la bande de gauche
NZ0f2 = PSK0_D.*Xf0 - PSKM1_D.*XfM1;
DZ0f2 = PSK0_G.*PSK0_D - PSKP1_G.*PSKM1_D;
Z0f_G = NZ0f2./DZ0f2;

% reconstitution du vecteur de longueur N final du spectre
Z = zeros(1,N/2-Nb/2);
Z = [ Z Z0f_G Z0f_D];
Z = [ Z zeros(1,length(x) - length(Z)) ];

fa  = 0:1/(dt*N):1/dt - 1/(dt*N);
fa = fa - fa(ceil(length(fa)/2) + 1);
t_graph(fa,Z,12,'FFT Totale');

% conversion du signal Z(f) reconstitu en z(t)
y4 = real(ifft(ifftshift(Z)));
figure(17);
plot(t,t_nrz(z),t,y4,'--k','LineWidth',2);
xlim([min(t) max(t)]);
legend('original','reconstruit');
