% David Legault 1070008
% Fichier: w_spectre.m
% Description: Fichier affichant un graphique de densit spectrale d'un signal
%
% Fonctions: w_spectre(x,Te,N,title)
%
% Variables:
%             x = vecteur du signal dans le temps
%             Te = Priode chantillonnage
%             N = numro de figure
%             title = titre du graphique

function w_spectre(x,Te,N,title)

Nx = length(x);

[Pxx,f] = periodogram(x,[],'twosided',Nx,1/Te);

figure(N);
Pxx = sqrt(Pxx);
%Pxx = log(Pxx);
Pxx = fftshift(Pxx);
f = f - f(ceil(length(f)/2) + 1);
psdplot(Pxx,f,'Hz','linear',title);
grid off;
%psdplot(Pxx,w,'Hz','db',title);

%axis([0 5 min(Pxx) max(Pxx)]);
%axis([0 w(ceil(length(w)/2)) min(Pxx) max(Pxx)]);