% David Legault 1070008
% Fichier: xt.m
% Description: Fonction qui calcul le signal rsultant x(t) avec les signaux Ak(t). Retourne le signal x(t) final
% filtr.
%
% Fonctions: xt(Ak,T0,dt)
%
% Variables:
%           Ak = matrice de signaux Ak(t)
%           T0 = priode du filtre LPTV
%           dt = intervalle d'chantillonnage

function y = xt(Ak,T0,dt)

y = [];

% calcul de la longueur des vecteurs de Ak en temps et selon le nombre Nk
nk = length(Ak(:,1));
nt = length(Ak(1,:));

% valeur minimale de k
kmin = -floor(nk/2);

% somme sur chacun de chantillons de temps
j = 0;
while j < nt
  
  % somme de -k a +k pour un temps donn
  yt = 0;
  k = 0;
  while k < nk
    
    yt = yt + Ak(k + 1,j + 1)*exp(i*(kmin+k)*2*pi*(1/T0)*j*dt);
    
    k = k + 1;
  end
  
  y = [y yt];
  j = j + 1;
end